*** a/src/backend/executor/nodeAgg.c
--- b/src/backend/executor/nodeAgg.c
***************
*** 3,9 ****
   * nodeAgg.c
   *	  Routines to handle aggregate nodes.
   *
!  *	  ExecAgg evaluates each aggregate in the following steps:
   *
   *		 transvalue = initcond
   *		 foreach input_tuple do
--- 3,9 ----
   * nodeAgg.c
   *	  Routines to handle aggregate nodes.
   *
!  *	  ExecAgg evaluates each normal aggregate in the following steps:
   *
   *		 transvalue = initcond
   *		 foreach input_tuple do
***************
*** 66,71 ****
--- 66,91 ----
   *	  AggState is available as context in earlier releases (back to 8.1),
   *	  but direct examination of the node is needed to use it before 9.0.
   *
+  *---
+  *
+  *    Ordered set functions modify the above process in a number of ways.
+  *    Most importantly, they do not have transfuncs at all; the same sort
+  *    mechanism used for ORDER BY/DISTINCT as described above is used to
+  *    process the input, but then the finalfunc is called without actually
+  *    running the sort (the finalfunc is allowed to insert rows first).
+  *    The finalfunc has access via a set of AggSet* API functions to the
+  *    Tuplesortstate, row count in the group, and other ancillary info.
+  *
+  *    Ordered set functions can, however, have a transvalue declared; this is
+  *    treated as a constant, and added to the end of the sort fields.
+  *    Hypothetical set functions use this to provide a flag that distinguishes
+  *    the hypothetical row from the input data.
+  *
+  *    Since they have no transfunc, ordered set functions have their own
+  *    'strict' flag stored in the aggregate's own pg_proc entry; this affects
+  *    whether rows containing nulls are placed in the sorter. But since we
+  *    pass dummy null arguments to the finalfunc for type resolution purposes,
+  *    no ordered set finalfunc is allowed to be strict.
   *
   * Portions Copyright (c) 1996-2013, PostgreSQL Global Development Group
   * Portions Copyright (c) 1994, Regents of the University of California
***************
*** 87,96 ****
--- 107,118 ----
  #include "executor/nodeAgg.h"
  #include "miscadmin.h"
  #include "nodes/nodeFuncs.h"
+ #include "nodes/makefuncs.h"
  #include "optimizer/clauses.h"
  #include "optimizer/tlist.h"
  #include "parser/parse_agg.h"
  #include "parser/parse_coerce.h"
+ #include "parser/parse_clause.h"
  #include "utils/acl.h"
  #include "utils/builtins.h"
  #include "utils/lsyscache.h"
***************
*** 105,110 ****
--- 127,134 ----
   */
  typedef struct AggStatePerAggData
  {
+ 	NodeTag type;
+ 	
  	/*
  	 * These values are set up during ExecInitAgg() and do not change
  	 * thereafter:
***************
*** 114,123 **** typedef struct AggStatePerAggData
  	AggrefExprState *aggrefstate;
  	Aggref	   *aggref;
  
! 	/* number of input arguments for aggregate function proper */
  	int			numArguments;
  
! 	/* number of inputs including ORDER BY expressions */
  	int			numInputs;
  
  	/* Oids of transfer functions */
--- 138,162 ----
  	AggrefExprState *aggrefstate;
  	Aggref	   *aggref;
  
! 	/* Pointer to parent AggState node */
! 	AggState   *aggstate;
! 
! 	/* copied from aggref */
! 	bool        isOrderedSet;
! 
! 	/*
! 	 * number of arguments for aggregate function proper.
! 	 * For ordered set functions, this includes the ORDER BY
! 	 * columns, *except* in the case of hypothetical set functions.
! 	 */
  	int			numArguments;
  
! 	/*
! 	 * number of inputs including ORDER BY expressions. For ordered
! 	 * set functions, *only* the ORDER BY expressions are included
! 	 * here, since the direct args to the function are not properly
! 	 * "input" in the sense of being derived from the tuple group.
! 	 */
  	int			numInputs;
  
  	/* Oids of transfer functions */
***************
*** 126,137 **** typedef struct AggStatePerAggData
  
  	/*
  	 * fmgr lookup data for transfer functions --- only valid when
! 	 * corresponding oid is not InvalidOid.  Note in particular that fn_strict
! 	 * flags are kept here.
  	 */
  	FmgrInfo	transfn;
  	FmgrInfo	finalfn;
  
  	/* Input collation derived for aggregate */
  	Oid			aggCollation;
  
--- 165,187 ----
  
  	/*
  	 * fmgr lookup data for transfer functions --- only valid when
! 	 * corresponding oid is not InvalidOid.
  	 */
  	FmgrInfo	transfn;
  	FmgrInfo	finalfn;
  
+ 	/*
+ 	 * If >0, aggregate as a whole is strict (skips null input)
+ 	 * The value specifies how many columns to check; normal aggs
+ 	 * only check numArguments, while ordered set functions check
+ 	 * numInputs.
+ 	 *
+ 	 * Ordered set functions are not allowed to have strict finalfns;
+ 	 * other aggregates respect the finalfn strict flag in the
+ 	 * FmgrInfo above.
+ 	 */
+ 	int         numStrict;
+ 
  	/* Input collation derived for aggregate */
  	Oid			aggCollation;
  
***************
*** 148,153 **** typedef struct AggStatePerAggData
--- 198,206 ----
  	Oid		   *sortCollations;
  	bool	   *sortNullsFirst;
  
+ 	/* just for convenience of ordered set funcs, not used here */
+ 	Oid		   *sortEqOperators;
+ 
  	/*
  	 * fmgr lookup data for input columns' equality operators --- only
  	 * set/used when aggregate has DISTINCT flag.  Note that these are in
***************
*** 204,209 **** typedef struct AggStatePerAggData
--- 257,265 ----
  	 */
  
  	Tuplesortstate *sortstate;	/* sort object, if DISTINCT or ORDER BY */
+ 
+ 	int64 number_of_rows;		/* number of rows */
+ 
  }	AggStatePerAggData;
  
  /*
***************
*** 300,305 **** initialize_aggregates(AggState *aggstate,
--- 356,363 ----
  		AggStatePerAgg peraggstate = &peragg[aggno];
  		AggStatePerGroup pergroupstate = &pergroup[aggno];
  
+ 		peraggstate->number_of_rows = 0;
+ 
  		/*
  		 * Start a fresh sort operation for each DISTINCT/ORDER BY aggregate.
  		 */
***************
*** 383,396 **** advance_transition_function(AggState *aggstate,
  	MemoryContext oldContext;
  	Datum		newVal;
  	int			i;
  
! 	if (peraggstate->transfn.fn_strict)
  	{
  		/*
  		 * For a strict transfn, nothing happens when there's a NULL input; we
  		 * just keep the prior transValue.
  		 */
! 		for (i = 1; i <= numArguments; i++)
  		{
  			if (fcinfo->argnull[i])
  				return;
--- 441,457 ----
  	MemoryContext oldContext;
  	Datum		newVal;
  	int			i;
+ 	int         numStrict = peraggstate->numStrict;
  
! 	Assert(OidIsValid(peraggstate->transfn_oid));
! 
! 	if (numStrict > 0)
  	{
  		/*
  		 * For a strict transfn, nothing happens when there's a NULL input; we
  		 * just keep the prior transValue.
  		 */
! 		for (i = 1; i <= numStrict; i++)
  		{
  			if (fcinfo->argnull[i])
  				return;
***************
*** 506,529 **** advance_aggregates(AggState *aggstate, AggStatePerGroup pergroup)
  
  		if (peraggstate->numSortCols > 0)
  		{
  			/* DISTINCT and/or ORDER BY case */
  			Assert(slot->tts_nvalid == peraggstate->numInputs);
  
  			/*
! 			 * If the transfn is strict, we want to check for nullity before
  			 * storing the row in the sorter, to save space if there are a lot
! 			 * of nulls.  Note that we must only check numArguments columns,
! 			 * not numInputs, since nullity in columns used only for sorting
! 			 * is not relevant here.
  			 */
! 			if (peraggstate->transfn.fn_strict)
  			{
! 				for (i = 0; i < nargs; i++)
  				{
  					if (slot->tts_isnull[i])
  						break;
  				}
! 				if (i < nargs)
  					continue;
  			}
  
--- 567,590 ----
  
  		if (peraggstate->numSortCols > 0)
  		{
+ 			int numStrict = peraggstate->numStrict;
+ 
  			/* DISTINCT and/or ORDER BY case */
  			Assert(slot->tts_nvalid == peraggstate->numInputs);
  
  			/*
! 			 * If the aggregate is strict, we want to check for nullity before
  			 * storing the row in the sorter, to save space if there are a lot
! 			 * of nulls.
  			 */
! 			if (numStrict > 0)
  			{
! 				for (i = 0; i < numStrict; i++)
  				{
  					if (slot->tts_isnull[i])
  						break;
  				}
! 				if (i < numStrict)
  					continue;
  			}
  
***************
*** 534,539 **** advance_aggregates(AggState *aggstate, AggStatePerGroup pergroup)
--- 595,602 ----
  								   slot->tts_isnull[0]);
  			else
  				tuplesort_puttupleslot(peraggstate->sortstate, slot);
+ 
+ 			peraggstate->number_of_rows++;
  		}
  		else
  		{
***************
*** 756,770 **** finalize_aggregate(AggState *aggstate,
  	if (OidIsValid(peraggstate->finalfn_oid))
  	{
  		FunctionCallInfoData fcinfo;
  
! 		InitFunctionCallInfoData(fcinfo, &(peraggstate->finalfn), 1,
! 								 peraggstate->aggCollation,
! 								 (void *) aggstate, NULL);
! 		fcinfo.arg[0] = pergroupstate->transValue;
! 		fcinfo.argnull[0] = pergroupstate->transValueIsNull;
! 		if (fcinfo.flinfo->fn_strict && pergroupstate->transValueIsNull)
  		{
! 			/* don't call a strict function with NULL inputs */
  			*resultVal = (Datum) 0;
  			*resultIsNull = true;
  		}
--- 819,884 ----
  	if (OidIsValid(peraggstate->finalfn_oid))
  	{
  		FunctionCallInfoData fcinfo;
+ 		bool isnull = false;
+ 
+ 		if (!(peraggstate->isOrderedSet))
+ 		{
+ 			InitFunctionCallInfoData(fcinfo,
+ 									 &(peraggstate->finalfn),
+ 									 1,
+ 									 peraggstate->aggCollation,
+ 									 (void *) aggstate,
+ 									 NULL);
+ 
+ 			fcinfo.arg[0] = pergroupstate->transValue;
+ 			fcinfo.argnull[0] = isnull = pergroupstate->transValueIsNull;
+ 		}
+ 		else
+ 		{
+ 			List     *args = peraggstate->aggrefstate->orddirectargs;
+ 			ListCell *lc;
+ 			int       i = 0;
+ 			int       numArguments = peraggstate->numArguments;
+ 
+ 			ExecClearTuple(peraggstate->evalslot);
+ 			ExecClearTuple(peraggstate->uniqslot);
+ 
+ 			InitFunctionCallInfoData(fcinfo,
+ 									 &(peraggstate->finalfn),
+ 									 peraggstate->numArguments,
+ 									 peraggstate->aggCollation,
+ 									 (void *) peraggstate,
+ 									 NULL);
+ 
+ 			foreach (lc, args)
+ 			{
+ 				ExprState *expr = (ExprState *) lfirst(lc);
+ 
+ 				fcinfo.arg[i] = ExecEvalExpr(expr,
+ 											 aggstate->ss.ps.ps_ExprContext,
+ 											 &fcinfo.argnull[i],
+ 											 NULL);
+ 				if (fcinfo.argnull[i])
+ 					isnull = true;
  
! 				++i;
! 			}
! 
! 			for(; i < numArguments; i++)
! 			{
! 				fcinfo.arg[i] = (Datum) 0;
! 				fcinfo.argnull[i] = true;
! 				isnull = true;
! 			}
! 		}
! 
! 		if (isnull && fcinfo.flinfo->fn_strict)
  		{
! 			/*
! 			 * don't call a strict function with NULL inputs; for ordered set
! 			 * functions this is paranoia, we already required that fn_strict
! 			 * is false, but easy to check anyway
! 			 */
  			*resultVal = (Datum) 0;
  			*resultIsNull = true;
  		}
***************
*** 1164,1169 **** agg_retrieve_direct(AggState *aggstate)
--- 1278,1294 ----
  		}
  
  		/*
+ 		 * Use the representative input tuple for any references to
+ 		 * non-aggregated input columns in the qual and tlist.	(If we are not
+ 		 * grouping, and there are no input rows at all, we will come here
+ 		 * with an empty firstSlot ... but if not grouping, there can't be any
+ 		 * references to non-aggregated input columns, so no problem.)
+ 		 * We do this before finalizing because for ordered set functions,
+ 		 * finalize_aggregates can evaluate arguments referencing the tuple.
+ 		 */
+ 		econtext->ecxt_outertuple = firstSlot;
+ 
+ 		/*
  		 * Done scanning input tuple group. Finalize each aggregate
  		 * calculation, and stash results in the per-output-tuple context.
  		 */
***************
*** 1174,1187 **** agg_retrieve_direct(AggState *aggstate)
  
  			if (peraggstate->numSortCols > 0)
  			{
! 				if (peraggstate->numInputs == 1)
! 					process_ordered_aggregate_single(aggstate,
! 													 peraggstate,
! 													 pergroupstate);
! 				else
! 					process_ordered_aggregate_multi(aggstate,
! 													peraggstate,
! 													pergroupstate);
  			}
  
  			finalize_aggregate(aggstate, peraggstate, pergroupstate,
--- 1299,1315 ----
  
  			if (peraggstate->numSortCols > 0)
  			{
! 				if (!(peraggstate->isOrderedSet))
! 				{
! 					if (peraggstate->numInputs == 1)
! 						process_ordered_aggregate_single(aggstate,
! 														 peraggstate,
! 														 pergroupstate);
! 					else
! 						process_ordered_aggregate_multi(aggstate,
! 														peraggstate,
! 														pergroupstate);
! 				}
  			}
  
  			finalize_aggregate(aggstate, peraggstate, pergroupstate,
***************
*** 1189,1203 **** agg_retrieve_direct(AggState *aggstate)
  		}
  
  		/*
- 		 * Use the representative input tuple for any references to
- 		 * non-aggregated input columns in the qual and tlist.	(If we are not
- 		 * grouping, and there are no input rows at all, we will come here
- 		 * with an empty firstSlot ... but if not grouping, there can't be any
- 		 * references to non-aggregated input columns, so no problem.)
- 		 */
- 		econtext->ecxt_outertuple = firstSlot;
- 
- 		/*
  		 * Check the qual (HAVING clause); if the group does not match, ignore
  		 * it and loop back to try to process another group.
  		 */
--- 1317,1322 ----
***************
*** 1568,1577 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
--- 1687,1698 ----
  		int			numInputs;
  		int			numSortCols;
  		int			numDistinctCols;
+ 		bool        isOrderedSet = aggref->isordset;
  		List	   *sortlist;
  		HeapTuple	aggTuple;
  		Form_pg_aggregate aggform;
  		Oid			aggtranstype;
+ 		Oid			aggtranstypecoll;
  		AclResult	aclresult;
  		Oid			transfn_oid,
  					finalfn_oid;
***************
*** 1580,1585 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
--- 1701,1710 ----
  		Datum		textInitVal;
  		int			i;
  		ListCell   *lc;
+         bool        is_strict;
+ 		Oid			inputCollations[FUNC_MAX_ARGS];
+ 		List       *argexprs;
+ 		List       *argexprstate;
  
  		/* Planner should have assigned aggregate to correct level */
  		Assert(aggref->agglevelsup == 0);
***************
*** 1601,1631 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  		/* Nope, so assign a new PerAgg record */
  		peraggstate = &peragg[++aggno];
  
- 		/* Mark Aggref state node with assigned index in the result array */
- 		aggrefstate->aggno = aggno;
- 
  		/* Fill in the peraggstate data */
! 		peraggstate->aggrefstate = aggrefstate;
  		peraggstate->aggref = aggref;
! 		numInputs = list_length(aggref->args);
! 		peraggstate->numInputs = numInputs;
! 		peraggstate->sortstate = NULL;
  
! 		/*
! 		 * Get actual datatypes of the inputs.	These could be different from
! 		 * the agg's declared input types, when the agg accepts ANY or a
! 		 * polymorphic type.
! 		 */
! 		numArguments = 0;
! 		foreach(lc, aggref->args)
! 		{
! 			TargetEntry *tle = (TargetEntry *) lfirst(lc);
  
! 			if (!tle->resjunk)
! 				inputTypes[numArguments++] = exprType((Node *) tle->expr);
! 		}
! 		peraggstate->numArguments = numArguments;
  
  		aggTuple = SearchSysCache1(AGGFNOID,
  								   ObjectIdGetDatum(aggref->aggfnoid));
  		if (!HeapTupleIsValid(aggTuple))
--- 1726,1743 ----
  		/* Nope, so assign a new PerAgg record */
  		peraggstate = &peragg[++aggno];
  
  		/* Fill in the peraggstate data */
! 		peraggstate->type = T_AggStatePerAggData;
! 		peraggstate->aggstate = aggstate;
  		peraggstate->aggref = aggref;
! 		peraggstate->aggrefstate = aggrefstate;
  
! 		peraggstate->isOrderedSet = isOrderedSet;
  
! 		/* Mark Aggref state node with assigned index in the result array */
! 		aggrefstate->aggno = aggno;
  
+ 		/* Fetch the pg_aggregate row */
  		aggTuple = SearchSysCache1(AGGFNOID,
  								   ObjectIdGetDatum(aggref->aggfnoid));
  		if (!HeapTupleIsValid(aggTuple))
***************
*** 1633,1638 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
--- 1745,1757 ----
  				 aggref->aggfnoid);
  		aggform = (Form_pg_aggregate) GETSTRUCT(aggTuple);
  
+ 		/*
+ 		 * Check that the definition hasn't somehow changed incompatibly.
+ 		 */
+ 		if (isOrderedSet != (aggform->aggisordsetfunc)
+ 			|| (aggref->ishypothetical != (aggform->aggordnargs == -2)))
+ 			elog(ERROR, "Incompatible change to aggregate definition");
+ 
  		/* Check permission to call aggregate function */
  		aclresult = pg_proc_aclcheck(aggref->aggfnoid, GetUserId(),
  									 ACL_EXECUTE);
***************
*** 1644,1668 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  		peraggstate->transfn_oid = transfn_oid = aggform->aggtransfn;
  		peraggstate->finalfn_oid = finalfn_oid = aggform->aggfinalfn;
  
! 		/* Check that aggregate owner has permission to call component fns */
  		{
  			HeapTuple	procTuple;
  			Oid			aggOwner;
  
  			procTuple = SearchSysCache1(PROCOID,
  										ObjectIdGetDatum(aggref->aggfnoid));
  			if (!HeapTupleIsValid(procTuple))
  				elog(ERROR, "cache lookup failed for function %u",
  					 aggref->aggfnoid);
! 			aggOwner = ((Form_pg_proc) GETSTRUCT(procTuple))->proowner;
  			ReleaseSysCache(procTuple);
  
! 			aclresult = pg_proc_aclcheck(transfn_oid, aggOwner,
! 										 ACL_EXECUTE);
! 			if (aclresult != ACLCHECK_OK)
  				aclcheck_error(aclresult, ACL_KIND_PROC,
  							   get_func_name(transfn_oid));
! 			InvokeFunctionExecuteHook(transfn_oid);
  			if (OidIsValid(finalfn_oid))
  			{
  				aclresult = pg_proc_aclcheck(finalfn_oid, aggOwner,
--- 1763,1799 ----
  		peraggstate->transfn_oid = transfn_oid = aggform->aggtransfn;
  		peraggstate->finalfn_oid = finalfn_oid = aggform->aggfinalfn;
  
! 		/*
! 		 * Check that aggregate owner has permission to call component fns
! 		 * In passing, fetch the proisstrict flag for the aggregate proper,
! 		 * which subs for the transfn's strictness flag in cases where there
! 		 * is no transfn.
! 		 */
  		{
  			HeapTuple	procTuple;
  			Oid			aggOwner;
+ 			Form_pg_proc procp;
  
  			procTuple = SearchSysCache1(PROCOID,
  										ObjectIdGetDatum(aggref->aggfnoid));
  			if (!HeapTupleIsValid(procTuple))
  				elog(ERROR, "cache lookup failed for function %u",
  					 aggref->aggfnoid);
! 			procp = (Form_pg_proc) GETSTRUCT(procTuple);
! 			aggOwner = procp->proowner;
! 			is_strict = procp->proisstrict;
  			ReleaseSysCache(procTuple);
  
! 			if (OidIsValid(transfn_oid))
! 			{
! 				aclresult = pg_proc_aclcheck(transfn_oid, aggOwner,
! 									         ACL_EXECUTE);
! 				if (aclresult != ACLCHECK_OK && OidIsValid(transfn_oid))
  				aclcheck_error(aclresult, ACL_KIND_PROC,
  							   get_func_name(transfn_oid));
! 				InvokeFunctionExecuteHook(transfn_oid);
! 			}
! 
  			if (OidIsValid(finalfn_oid))
  			{
  				aclresult = pg_proc_aclcheck(finalfn_oid, aggOwner,
***************
*** 1674,1690 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  			}
  		}
  
  		/* resolve actual type of transition state, if polymorphic */
  		aggtranstype = aggform->aggtranstype;
! 		if (IsPolymorphicType(aggtranstype))
  		{
  			/* have to fetch the agg's declared input types... */
  			Oid		   *declaredArgTypes;
! 			int			agg_nargs;
  
  			(void) get_func_signature(aggref->aggfnoid,
! 									  &declaredArgTypes, &agg_nargs);
! 			Assert(agg_nargs == numArguments);
  			aggtranstype = enforce_generic_type_consistency(inputTypes,
  															declaredArgTypes,
  															agg_nargs,
--- 1805,1841 ----
  			}
  		}
  
+ 		/*
+ 		 * Get actual datatypes of the inputs.	These could be different from
+ 		 * the agg's declared input types, when the agg accepts ANY or a
+ 		 * polymorphic type.
+ 		 */
+ 
+ 		peraggstate->numInputs = numInputs = list_length(aggref->args);
+ 
+ 		numArguments = get_aggregate_argtypes(aggref,
+ 											  inputTypes,
+ 											  inputCollations);
+ 
  		/* resolve actual type of transition state, if polymorphic */
  		aggtranstype = aggform->aggtranstype;
! 		if (OidIsValid(aggtranstype) && IsPolymorphicType(aggtranstype))
  		{
  			/* have to fetch the agg's declared input types... */
  			Oid		   *declaredArgTypes;
! 			int         agg_nargs;
  
  			(void) get_func_signature(aggref->aggfnoid,
! 									  &declaredArgTypes,
! 									  &agg_nargs);
! 
! 			/*
! 			 * if variadic "any", might be more actual args than declared
! 			 * args, but these extra args can't influence the determination
! 			 * of polymorphic transition or result type.
! 			 */
! 			Assert(agg_nargs <= numArguments);
! 
  			aggtranstype = enforce_generic_type_consistency(inputTypes,
  															declaredArgTypes,
  															agg_nargs,
***************
*** 1693,1727 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  			pfree(declaredArgTypes);
  		}
  
  		/* build expression trees using actual argument & result types */
! 		build_aggregate_fnexprs(inputTypes,
! 								numArguments,
! 								aggref->aggvariadic,
! 								aggtranstype,
! 								aggref->aggtype,
! 								aggref->inputcollid,
! 								transfn_oid,
! 								finalfn_oid,
! 								&transfnexpr,
! 								&finalfnexpr);
! 
! 		fmgr_info(transfn_oid, &peraggstate->transfn);
! 		fmgr_info_set_expr((Node *) transfnexpr, &peraggstate->transfn);
  
  		if (OidIsValid(finalfn_oid))
  		{
  			fmgr_info(finalfn_oid, &peraggstate->finalfn);
  			fmgr_info_set_expr((Node *) finalfnexpr, &peraggstate->finalfn);
  		}
  
  		peraggstate->aggCollation = aggref->inputcollid;
  
  		get_typlenbyval(aggref->aggtype,
  						&peraggstate->resulttypeLen,
  						&peraggstate->resulttypeByVal);
! 		get_typlenbyval(aggtranstype,
! 						&peraggstate->transtypeLen,
! 						&peraggstate->transtypeByVal);
  
  		/*
  		 * initval is potentially null, so don't try to access it as a struct
--- 1844,1925 ----
  			pfree(declaredArgTypes);
  		}
  
+ 		aggtranstypecoll = get_typcollation(aggtranstype);
+ 
  		/* build expression trees using actual argument & result types */
! 
! 		if (!isOrderedSet)
! 		{
! 			build_aggregate_fnexprs(inputTypes,
! 									numArguments,
! 									aggref->aggvariadic,
! 									aggtranstype,
! 									aggref->aggtype,
! 									aggref->inputcollid,
! 									transfn_oid,
! 									finalfn_oid,
! 									&transfnexpr,
! 									&finalfnexpr);
! 		}
! 		else
! 		{
! 			/*
! 			 * The transvalue counts as an argument, but not for hypothetical
! 			 * set funcs.
! 			 */
! 			if (OidIsValid(aggtranstype) && !(aggref->ishypothetical))
! 			{
! 				if (numArguments == FUNC_MAX_ARGS)
! 					elog(ERROR, "Too many arguments to ordered set function");
! 
! 				inputTypes[numArguments++] = aggtranstype;
! 				inputCollations[numArguments++] = aggtranstypecoll;
! 			}
! 
! 			build_orderedset_fnexprs(inputTypes,
! 									 numArguments,
! 									 aggref->aggvariadic,
! 									 aggref->aggtype,
! 									 aggref->inputcollid,
! 									 inputCollations,
! 									 finalfn_oid,
! 									 &finalfnexpr);
! 		}
! 
! 		peraggstate->numArguments = numArguments;
! 
! 		if (OidIsValid(transfn_oid))
! 		{
! 			fmgr_info(transfn_oid, &peraggstate->transfn);
! 			fmgr_info_set_expr((Node *) transfnexpr, &peraggstate->transfn);
! 
! 			is_strict = peraggstate->transfn.fn_strict;
! 		}
  
  		if (OidIsValid(finalfn_oid))
  		{
  			fmgr_info(finalfn_oid, &peraggstate->finalfn);
  			fmgr_info_set_expr((Node *) finalfnexpr, &peraggstate->finalfn);
+ 			if (peraggstate->finalfn.fn_strict && isOrderedSet)
+ 				elog(ERROR, "Ordered set finalfns must not be strict");
  		}
  
+ 		if (is_strict)
+ 			peraggstate->numStrict = (isOrderedSet ? numInputs : numArguments);
+ 		else
+ 			peraggstate->numStrict = 0;
+ 
  		peraggstate->aggCollation = aggref->inputcollid;
  
  		get_typlenbyval(aggref->aggtype,
  						&peraggstate->resulttypeLen,
  						&peraggstate->resulttypeByVal);
! 		if (OidIsValid(aggtranstype))
! 		{
! 			get_typlenbyval(aggtranstype,
! 							&peraggstate->transtypeLen,
! 							&peraggstate->transtypeByVal);
! 		}
  
  		/*
  		 * initval is potentially null, so don't try to access it as a struct
***************
*** 1744,1750 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  		 * transValue.	This should have been checked at agg definition time,
  		 * but just in case...
  		 */
! 		if (peraggstate->transfn.fn_strict && peraggstate->initValueIsNull)
  		{
  			if (numArguments < 1 ||
  				!IsBinaryCoercible(inputTypes[0], aggtranstype))
--- 1942,1950 ----
  		 * transValue.	This should have been checked at agg definition time,
  		 * but just in case...
  		 */
! 		if (OidIsValid(peraggstate->transfn_oid)
! 			&& peraggstate->transfn.fn_strict
! 			&& peraggstate->initValueIsNull)
  		{
  			if (numArguments < 1 ||
  				!IsBinaryCoercible(inputTypes[0], aggtranstype))
***************
*** 1754,1774 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  								aggref->aggfnoid)));
  		}
  
! 		/*
! 		 * Get a tupledesc corresponding to the inputs (including sort
! 		 * expressions) of the agg.
! 		 */
! 		peraggstate->evaldesc = ExecTypeFromTL(aggref->args, false);
! 
! 		/* Create slot we're going to do argument evaluation in */
! 		peraggstate->evalslot = ExecInitExtraTupleSlot(estate);
! 		ExecSetSlotDescriptor(peraggstate->evalslot, peraggstate->evaldesc);
! 
! 		/* Set up projection info for evaluation */
! 		peraggstate->evalproj = ExecBuildProjectionInfo(aggrefstate->args,
! 														aggstate->tmpcontext,
! 														peraggstate->evalslot,
! 														NULL);
  
  		/*
  		 * If we're doing either DISTINCT or ORDER BY, then we have a list of
--- 1954,1961 ----
  								aggref->aggfnoid)));
  		}
  
! 		argexprs = aggref->args;
! 		argexprstate = aggrefstate->args;
  
  		/*
  		 * If we're doing either DISTINCT or ORDER BY, then we have a list of
***************
*** 1777,1782 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
--- 1964,1974 ----
  		 *
  		 * Note that by construction, if there is a DISTINCT clause then the
  		 * ORDER BY clause is a prefix of it (see transformDistinctClause).
+ 		 *
+ 		 * If we're doing an ordered set function, though, we want to do the
+ 		 * initialization for DISTINCT since the ordered set finalfn might
+ 		 * want it, and it's much easier to do it here. So set numDistinctCols
+ 		 * and let the later initialization take care of it.
  		 */
  		if (aggref->aggdistinct)
  		{
***************
*** 1788,1798 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  		{
  			sortlist = aggref->aggorder;
  			numSortCols = list_length(sortlist);
! 			numDistinctCols = 0;
  		}
  
  		peraggstate->numSortCols = numSortCols;
  		peraggstate->numDistinctCols = numDistinctCols;
  
  		if (numSortCols > 0)
  		{
--- 1980,2065 ----
  		{
  			sortlist = aggref->aggorder;
  			numSortCols = list_length(sortlist);
! 			numDistinctCols = isOrderedSet ? numSortCols : 0;
! 		}
! 
! 		/*
! 		 * If this is an ordered set function, and we have a transtype, then
! 		 * it represents an extra column to be added to the sorter with a
! 		 * fixed value. Plus, if aggtranssortop is valid, we have to include
! 		 * a sort entry for the new column.
! 		 *
! 		 * I'd probably have done this in the planner if I'd seen any
! 		 * possible place to put it; if there is one, it's very obscure.
! 		 */
! 
! 		if (OidIsValid(aggtranstype) && isOrderedSet)
! 		{
! 			Oid sortop = aggform->aggtranssortop;
! 			Const *node = makeNode(Const);
! 			TargetEntry *tle;
! 			SortGroupClause *sortcl = NULL;
! 
! 			node->consttype = aggtranstype;
! 			node->consttypmod = -1;
! 			node->constcollid = aggtranstypecoll;
! 			node->constlen = peraggstate->transtypeLen;
! 			node->constvalue = peraggstate->initValue;
! 			node->constisnull = peraggstate->initValueIsNull;
! 			node->constbyval = peraggstate->transtypeByVal;
! 			node->location = -1;
! 
! 			tle = makeTargetEntry((Expr *) node,
! 								  ++numInputs,
! 								  NULL,
! 								  true);
! 
! 			peraggstate->numInputs = numInputs;
! 
! 			if (OidIsValid(sortop))
! 			{
! 				Assert(aggref->aggdistinct == NIL);
! 
! 				sortcl = makeNode(SortGroupClause);
! 
! 				sortcl->tleSortGroupRef = assignSortGroupRef(tle, argexprs);
! 
! 				sortcl->sortop = sortop;
! 				sortcl->hashable = false;
! 				sortcl->eqop = get_equality_op_for_ordering_op(sortop,
! 															   &sortcl->nulls_first);
! 
! 				sortlist = lappend(list_copy(sortlist), sortcl);
! 				++numSortCols;
! 				++numDistinctCols;
! 			}
! 
! 			/* shallow-copy the passed-in lists, which we must not scribble on. */
! 
! 			argexprs = lappend(list_copy(argexprs), (Node *) tle);
! 			argexprstate = lappend(list_copy(argexprstate),
! 								   ExecInitExpr((Expr *) tle, (PlanState *) aggstate));
  		}
  
  		peraggstate->numSortCols = numSortCols;
  		peraggstate->numDistinctCols = numDistinctCols;
+ 		peraggstate->sortstate = NULL;
+ 
+ 		/*
+ 		 * Get a tupledesc corresponding to the inputs (including sort
+ 		 * expressions) of the agg.
+ 		 */
+ 		peraggstate->evaldesc = ExecTypeFromTL(argexprs, false);
+ 
+ 		/* Create slot we're going to do argument evaluation in */
+ 		peraggstate->evalslot = ExecInitExtraTupleSlot(estate);
+ 		ExecSetSlotDescriptor(peraggstate->evalslot, peraggstate->evaldesc);
+ 
+ 		/* Set up projection info for evaluation */
+ 		peraggstate->evalproj = ExecBuildProjectionInfo(argexprstate,
+ 														aggstate->tmpcontext,
+ 														peraggstate->evalslot,
+ 														NULL);
  
  		if (numSortCols > 0)
  		{
***************
*** 1805,1815 **** ExecInitAgg(Agg *node, EState *estate, int eflags)
  			/* If we have only one input, we need its len/byval info. */
  			if (numInputs == 1)
  			{
! 				get_typlenbyval(inputTypes[0],
  								&peraggstate->inputtypeLen,
  								&peraggstate->inputtypeByVal);
  			}
! 			else if (numDistinctCols > 0)
  			{
  				/* we will need an extra slot to store prior values */
  				peraggstate->uniqslot = ExecInitExtraTupleSlot(estate);
--- 2072,2083 ----
  			/* If we have only one input, we need its len/byval info. */
  			if (numInputs == 1)
  			{
! 				get_typlenbyval(peraggstate->evaldesc->attrs[0]->atttypid,
  								&peraggstate->inputtypeLen,
  								&peraggstate->inputtypeByVal);
  			}
! 
! 			if (numDistinctCols > 0 && (numInputs > 1 || isOrderedSet))
  			{
  				/* we will need an extra slot to store prior values */
  				peraggstate->uniqslot = ExecInitExtraTupleSlot(estate);
